"{ Package: 'cvut:fel/cface' }"

"{ NameSpace: Cface }"

Object subclass:#TypeMapping
	instanceVariableNames:'smalltalkPackage'
	classVariableNames:''
	poolDictionaries:''
	category:'Cface-Mappings'
!


!TypeMapping methodsFor:'accessing'!

kindForFunction:cFunction

    |firstArgType|

    cFunction arguments isEmpty ifTrue:[^#static].
    firstArgType := cFunction arguments first type.
    ^(firstArgType isCPointerNode and:[firstArgType type isCStructNode])
        ifTrue:[#method]
        ifFalse:[#static]





    "Answers class which should contain function call"

    "Created: / 03-07-2008 / 22:09:41 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

smalltalkCategoryForDerivedType:cType 

    ^self smalltalkNamespace , ' - C Types'

    "Created: / 10-07-2008 / 08:06:58 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

smalltalkCategoryForEnum: enum

    ^self smalltalkNamespace , ' - Constants'

    "Answers class which should contain function call"

    "Created: / 10-07-2008 / 08:07:31 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

smalltalkCategoryForStruct:struct 
    ^ self smalltalkCategoryForDerivedType:struct

    "Answers class which should contain function call"

    "Created: / 10-07-2008 / 08:07:12 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

smalltalkCategoryForUnion:union 
    ^ self smalltalkCategoryForDerivedType:union

    "Answers class which should contain function call"

    "Created: / 10-07-2008 / 08:06:05 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

smalltalkClassNameForDerivedType:cType 
    ^ self smalltalkize:cType cName

    "Created: / 10-07-2008 / 08:05:42 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

smalltalkClassNameForEnum:cEnum 
    ^ self smalltalkClassNameForDerivedType:cEnum

    "Answers class which should contain function call"

    "Created: / 10-07-2008 / 07:58:36 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

smalltalkClassNameForFunction:cFunction 
    |firstArgType|

    cFunction arguments isEmpty ifTrue:[
        ^ nil
    ].
    firstArgType := cFunction arguments first type.
    ^ (firstArgType isCPointerNode and:[ firstArgType type isCStructNode ]) 
        ifTrue:[ firstArgType type smalltalkClassName ]
        ifFalse:[ nil ]

    "Answers class which should contain function call"

    "Created: / 10-07-2008 / 07:58:56 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

smalltalkClassNameForStruct:cStruct 
    ^ self smalltalkClassNameForDerivedType:cStruct

    "Answers class which should contain function call"

    "Created: / 10-07-2008 / 07:59:08 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

smalltalkClassNameForUnion:union 
    ^ self smalltalkClassNameForDerivedType:union

    "Answers class which should contain function call"

    "Created: / 10-07-2008 / 07:59:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

smalltalkNameForEnumValue:cEnumField 
    ^ self smalltalkClassNameForDerivedType:cEnumField

    "Answers class which should contain function call"

    "Created: / 04-07-2008 / 11:32:01 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 10-07-2008 / 08:05:42 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

smalltalkNameForStructField:cStructField
    ^ self smalltalkize: cStructField cName

    "Created: / 17-02-2008 / 21:22:15 / janfrog"
!

smalltalkNamespace

    ^#Smalltalk

    "Created: / 17-02-2008 / 20:51:05 / janfrog"
!

smalltalkPackage
    ^ smalltalkPackage

    "Created: / 03-07-2008 / 21:12:55 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

smalltalkPackage:package
    smalltalkPackage := package.

    "Created: / 03-07-2008 / 21:12:55 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

smalltalkSelectorForFunction:cFunction

    ^self smalltalkizeSelector: cFunction cName forFunction: cFunction

    "Created: / 17-02-2008 / 22:15:44 / janfrog"
    "Modified: / 04-07-2008 / 15:16:45 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!TypeMapping methodsFor:'private - utilities'!

smalltalkize: input

    | inputStream outputStream |
    inputStream := input readStream.
    outputStream := (String new:input size) writeStream.
    [ inputStream atEnd ] whileFalse:
        [|c|
        c := inputStream next.
        c = $_ 
            ifTrue:[outputStream nextPut: inputStream next asUppercase]
            ifFalse:[outputStream nextPut: c]].
    ^outputStream contents.

    "
        Cface::TypeMapping new smalltalkize:'test'   
        Cface::TypeMapping new smalltalkize:'test_of_smalltalkize'    
    "

    "Created: / 08-02-2008 / 09:34:40 / janfrog"
    "Modified: / 03-07-2008 / 22:31:24 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

smalltalkizeSelector: translatedFunctionName forFunction: cFunction

    ^String streamContents:
        [:s|
        s nextPutAll:(self smalltalkize: translatedFunctionName).
        cFunction arguments size > 0 ifTrue:
            [s nextPut:$:].
        cFunction arguments size > 1 ifTrue:
            [(cFunction arguments copyFrom:2) do:
                [:argument|
                s 
                    nextPutAll: (self smalltalkize: argument cName);
                    nextPut:$:]]]

    "Created: / 04-07-2008 / 15:16:13 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!TypeMapping class methodsFor:'documentation'!

version
    ^ '$Header: /opt/data/cvs/cvut-fel/cface/Cface__TypeMapping.st,v 1.1 2008/02/26 16:00:36 vranyj1 Exp $'
! !
